Unit Main;

Interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, DXClass, DXSprite, DXInput, DXDraws;

type

  TDirection = (DrUp, DrDown, DrLeft, DrRight, DrUpLeft, DrUpRight, DrDownLeft, DrDownRight);
  {ԶϷõķ}

  TPlayerSprite = class (TImageSprite)
  CanMove: Boolean;
  protected
    procedure DoMove(MoveCount: Integer); override;
    procedure MoveTo(MoveCount:Integer; Direction: TDirection);
    procedure DoCollision(Sprite: TSprite; var Done: Boolean); override;
  end;

  TMainForm = class(TDXForm) {˴ʹŻTDXFormTForm}
    DXTimer: TDXTimer;
    DXDraw: TDXDraw;
    DXSpriteEngine: TDXSpriteEngine;
    DXInput: TDXInput;
    ImageList: TDXImageList;
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure DXDrawFinalize(Sender: TObject);
    procedure DXDrawInitialize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DXTimerTimer(Sender: TObject; LagCount: Integer);
    procedure DXDrawMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure DXDrawMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure DXDrawMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    AnchorX: Integer;
    AnchorY: Integer; {λ}
    MouseX: Integer;
    MouseY: Integer; {굱ǰλ}
    PlayerSprite: TPlayerSprite; {ϷƵ}
    BackSprite: TBackGroundSprite; {Ϸıͼ}
  end;

const
  speed=5; {Ϸ˶ʱĶٶ}

var
  MainForm: TMainForm;
  Steps: Integer; {ڿл鶯ͼƬĲ}


implementation

{$R *.DFM}

procedure TPlayerSprite.DoCollision(Sprite: TSprite; var Done: Boolean);
begin
  Done:=False; {Ѿ⵽ײظײ}
  {ϷǷ鷢ײ˴չΪԻ}
end;

procedure TPlayerSprite.DoMove(MoveCount: Integer);
var
  l,r,d,u: Boolean;
  absX,absY: Integer; {ϷĵǰλĿĵصľԾ}
begin
  inherited DoMove(MoveCount);
  MoveCount:=Trunc(MoveCount*1.5);
  l:=false; r:=false; u:=false; d:=false;

  if (Trunc(X)-MainForm.AnchorX>0) then l:=true else r:=true;
  if (Trunc(Y)-MainForm.AnchorY>0) then u:=true else d:=true;

  absX:=abs(Trunc(X)-MainForm.AnchorX);
  absY:=abs(Trunc(Y)-MainForm.AnchorY);

  if absX<4 then begin l:=false; r:=false; end;
  if absY<4 then begin u:=false; d:=false; end;
  {ԾѾСĸأΪѾĿĵ}

  if u and l and not d and not r then MoveTo(MoveCount,DrUpLeft);
  if u and r and not l and not d then MoveTo(MoveCount,DrUpRight);
  if d and l and not r and not u then MoveTo(MoveCount,DrDownLeft);
  if d and r and not u and not l then MoveTo(MoveCount,DrDownRight);
  if d and not l and not r and not u then MoveTo(MoveCount,DrDown);
  if u and not l and not r and not d then MoveTo(MoveCount,DrUp);
  if l and not u and not r and not d then MoveTo(MoveCount,DrLeft);
  if r and not l and not u and not d then MoveTo(MoveCount,DrRight);
  {Ŀĵж˶ķ򣬴ӶӦ˶Ķ}

  Collision; {ײ}
  Engine.X := -X+Engine.Width div 2 - Width div 2;
  Engine.Y := -Y+Engine.Height div 2 - Height div 2;
  {ƶ棬ӶϷﴦ̨}
end;


procedure TMainForm.DXTimerTimer(Sender: TObject; LagCount: Integer);
begin
  if not DXDraw.CanDraw then exit;
  {DXDrawǷԻ˳}
  DXInput.Update;
  {׽豸룬}

  LagCount := 1000 div 60;
  {ϷٶȵĲ}
  DXSpriteEngine.Move(LagCount);
  DXSpriteEngine.Dead;

  DXDraw.Surface.Fill(0);
  {ĻΪɫ}
  DXSpriteEngine.Draw;

  with DXDraw.Surface.Canvas do
  begin
    brush.style:=bsclear;
    pen.style:=psclear;
    pen.color:=clwhite;
    Font.Color:=clWhite;
    Font.Size:=10;

    textout(10,10,'Press ESC to Quit');
    textout(100,100,'X: '+IntToStr(AnchorX)+'Y: '+IntToStr(AnchorY));
    {λþתϷе}
    textout(100,200,'Sprit x:'+IntToStr(Trunc(PlayerSprite.x))+'Y: '+IntToStr(Trunc(PlayerSprite.y)));
    {Ϸе}
    textout(100,300,'Relative x:'+IntToStr(AnchorX-Trunc(PlayerSprite.x))+'Y: '+IntToStr(AnchorY-Trunc(PlayerSprite.y)));
    {鵱ǰλĿĵ֮ľԾ}
    textout(200,100,'Mouse x:'+IntToStr(MainForm.MouseX)+'Y: '+IntToStr(MainForm.MouseY));
    {굱ǰλãڴϽǣδתΪϷ}
    Release;
  end;
  {ĸӦڳ}
  DXDraw.Flip;
  {ڴеĺ̨淭תǰʾ}
end;

procedure TMainForm.DXDrawFinalize(Sender: TObject);
begin
  DXTimer.Enabled := False;
  {رնʱ}
end;

procedure TMainForm.DXDrawInitialize(Sender: TObject);
begin
  DXTimer.Enabled := True;
  {ʱ}
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Steps:=0;
  AnchorX:=0;
  AnchorY:=0;

  MouseX:=320;
  MouseY:=240;
  {Ĭʹ괦Ļ}


  ImageList.Items.MakeColorTable;

  DXDraw.ColorTable := ImageList.Items.ColorTable;
  DXDraw.DefColorTable := ImageList.Items.ColorTable;
  DXDraw.UpdatePalette;
  {ϵͳɫ}

  BackSprite:=TBackgroundSprite.Create(DXSpriteEngine.Engine);
  with TBackgroundSprite(BackSprite) do
  begin
    SetMapSize(1, 1);{趨ʾʽΪ11}
    Image := ImageList.Items.Find('background'); {뱳ͼƬ}
    Z := -2;  {趨}
    Tile := True; {趨ʽΪƽ}
  end;

  PlayerSprite := TPlayerSprite.Create(DXSpriteEngine.Engine);
  with TPlayerSprite(PlayerSprite) do
  begin
    Image := ImageList.Items.Find('player');
    Z := 2;
    Width := Image.Width;
    Height := Image.Height;
  end;
  {Ϸ}
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {Esc˳}
  if Key=VK_ESCAPE then
    Close;

  {ȫģʽʹģʽл}
  if (ssAlt in Shift) and (Key=VK_RETURN) then
  begin
    DXDraw.Finalize;

    if doFullScreen in DXDraw.Options then
    begin
      RestoreWindow;

      DXDraw.Cursor := crNone;
      BorderStyle := bsSizeable;
      DXDraw.Options := DXDraw.Options - [doFullScreen];
    end else
    begin
      StoreWindow;

      DXDraw.Cursor := crNone;
      BorderStyle := bsNone;
      DXDraw.Options := DXDraw.Options + [doFullScreen];
    end;

    DXDraw.Initialize;
  end;
end;


procedure TMainForm.DXDrawMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  AnchorX := x + Trunc(PlayerSprite.x)-320;
  AnchorY := y + Trunc(PlayerSprite.y)-240;
  {ĻϵλתϷ}
  PlayerSprite.CanMove:=True;
  {˲϶}
end;

procedure TMainForm.DXDrawMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if PlayerSprite.CanMove then
  begin
    AnchorX := x + Trunc(PlayerSprite.x)-320;
    AnchorY := y + Trunc(PlayerSprite.y)-240;
    {϶нĻϵλתϷ}
  end;

  MouseX:=X;
  MouseY:=Y;
  {굱ǰλ}
end;

procedure TMainForm.DXDrawMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  PlayerSprite.CanMove:=False;
end;


procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DXSpriteEngine.Free;
end;

procedure TPlayerSprite.MoveTo(MoveCount: Integer; Direction: TDirection);
begin
  {ƾƶ}
  case Direction of
  DrUp:
    begin
      Y := Y-(150/1000)*MoveCount;
      Inc(steps);
      AnimPos:=steps div speed+20+1;
      {ǰвŵͼƬ}
      if steps>4*speed-2 then steps:=0;
    end;
  DrDown:
    begin
      Y := Y+(150/1000)*MoveCount;
      Inc(steps);
      AnimPos:=steps div speed+1;
      if steps> 4*speed-2 then steps:=0;
    end;
  DrLeft:
    begin
      X := X-(150/1000)*MoveCount;
      Inc(steps);
      AnimPos:=steps div speed+10+1;
      if steps>4*speed-2 then steps:=0;
    end;
  DrRight:
    begin
      X := X+(150/1000)*MoveCount;
      Inc(steps);
      AnimPos:=steps div speed+30+1;
      if steps>4*speed-2 then steps:=0;
    end;
  DrUpLeft:
    begin
      X := X-(150/1000)*MoveCount;
      Y := Y-(150/1000)*MoveCount;
      Inc(steps);
      AnimPos:=steps div speed+15+1;
      if steps>4*speed-2 then steps:=0;
    end;
  DrUpRight:
    begin
      X := X+(150/1000)*MoveCount;
      Y := Y-(150/1000)*MoveCount;
      Inc(steps);
      AnimPos:=steps div speed+25+1;
      if steps>4*speed-2 then steps:=0;
    end;
  DrDownLeft:
    begin
      X := X-(150/1000)*MoveCount;
      Y := Y+(150/1000)*MoveCount;
      Inc(steps);
      AnimPos:=steps div speed+5+1;
      if steps>4*speed-2 then steps:=0;
    end;
  DrDownRight:
    begin
      X := X + (150/1000)*MoveCount;
      Y := Y + (150/1000)*MoveCount;
      Inc(steps);
      AnimPos:=steps div speed+35+1;
      if steps>4*speed-2 then steps:=0;
    end;
  end;
end;

end.
